import lia.Monitor.monitor.*;

import java.io.*;
import java.util.*;
import java.net.InetAddress;
import java.net.*;

public class aGanglia2 extends cmdExec implements  MonitoringModule {


String[] tmetric;
String[] clusterMetric={"NCPUS", "Load1", "Average1", "Load5", "Average5"};
int size = clusterMetric.length;

// Default values
String gangliaHost = "ganglia01.rcf.bnl.gov";
int gangliaPort = 8652;

String [] ijobs;
  
String args ;
static public String ModuleName="aGanglia2";
String[] Queues;

public aGanglia2  () { 
   super( ModuleName );
   info.ResTypes = tmetric;
   System.out.println ( "Start the Interface to aGanlia" );
   isRepetitive = true;
}

public  MonModuleInfo init( MNode Node , String args ) {
    this.Node = Node;

    if ( args != null ) { 
        System.out.println("args: "+args);
        StringTokenizer tz = new StringTokenizer(args,",");
        gangliaHost = tz.nextToken();
        gangliaPort= new Integer(tz.nextToken()).intValue();

//      int k = tz.countTokens();
      int k =2;
      tmetric = new String [k];
      ijobs = new String[k];

    }
    info.ResTypes = tmetric;
    this.args = args;


    return info;
}


public Object  doProcess() throws Exception  {


   Vector testV = new Vector();
   testV = collectClusterInfo();

//   for (int j=0; j<testV.size(); j++) {
//       System.out.println("testV("+j+")="+testV.get(j));
//   }   

   return testV;

}


public MonModuleInfo getInfo(){
        return info;
}


public String[] ResTypes () {
  return tmetric;
}

public String getOsName() { return "linux"; }


public Vector collectClusterInfo() {
    Vector clusterResults = new Vector();
    Result rr = null;
    Result rrc = null;

    Socket gangliaSocket = null;
    PrintWriter out = null;
    BufferedReader in = null;

    try {
        gangliaSocket = new Socket(gangliaHost, gangliaPort);
        out = new PrintWriter(gangliaSocket.getOutputStream(), true);
        in = new BufferedReader( new InputStreamReader(gangliaSocket.getInputStream()));
    } catch (Exception e){
        System.out.println("Exception: "+e);
    }
        
    try {
        String line;
        int gncpus=0;
        double gload1=0.;
        double gload5=0.;
        int ncpus=0;
        double load1=0.;
        double load5=0.;
        out.println("/?filter=summary");
        while ( (line = in.readLine()) != null ) {
//        System.out.println(line);

          if (line.indexOf("<GRID") != -1) { //found GRID Element
  rr = new Result(Node.getFarmName(), Node.getClusterName(), "All", ModuleName, clusterMetric );
  rr.time = (new Date()).getTime();

             while ( ((line=in.readLine()) != null) && (line.indexOf("</GRID")) == -1 ) {  
//                System.out.println("GRID line: "+line);
                 if ( line.indexOf("<METRIC") != -1) {
                    if (line.indexOf("cpu_num") != -1 ) {
                       int i3 = line.indexOf("SUM");
                       int i4 = line.indexOf("\"", i3+5);
                       gncpus = new Integer(line.substring(i3+5, i4)).intValue();
                       rr.param[0]=gncpus;
//                       System.out.println("GRID npus: "+gncpus);
                    }
                    if (line.indexOf("load_one") != -1) {
                       int i3 = line.indexOf("SUM");
                       int i4 = line.indexOf("\"", i3+5);
                       gload1 = new Float(line.substring(i3+5, i4)).doubleValue();
                       rr.param[1]=gload1;
                       rr.param[2]=gload1/gncpus;
//                       System.out.println("GRID load1: "+gload1);
                    }
                    if (line.indexOf("load_five") != -1) {
                       int i3 = line.indexOf("SUM");
                       int i4 = line.indexOf("\"", i3+5);
                       gload5 = new Float(line.substring(i3+5, i4)).doubleValue();
                       rr.param[3]=gload5;
                       rr.param[4]=gload5/gncpus;
//                       System.out.println("GRID load5: "+gload5);
                    }
                  } // if METRIC

                  if (line.indexOf("<CLUSTER") != -1) { //found CLUSTER Element
              int i1 = line.indexOf("=");
              int i2 = line.indexOf("\"", i1+2);
              String clu = line.substring(i1+2, i2);
              String cluster = clu.replace(' ','_');
//              System.out.println("Cluster Name: "+cluster);
  rrc = new Result(Node.getFarmName(), Node.getClusterName(), cluster, ModuleName, clusterMetric );
  rrc.time = (new Date()).getTime();
              while ( ((line=in.readLine()) != null) && (line.indexOf("</CLUSTER")) == -1 ) {  
                 if ( line.indexOf("<METRIC") != -1) {
                    if (line.indexOf("cpu_num") != -1 ) {
                       int i3 = line.indexOf("SUM");
                       int i4 = line.indexOf("\"", i3+5);
                       ncpus = new Integer(line.substring(i3+5, i4)).intValue();
                       rrc.param[0]=ncpus;
//                       System.out.println( cluster+" npus: "+ncpus);
                    }
                    if (line.indexOf("load_one") != -1) {
                       int i3 = line.indexOf("SUM");
                       int i4 = line.indexOf("\"", i3+5);
                       load1 = new Float(line.substring(i3+5, i4)).doubleValue();
                       rrc.param[1]=load1;
//                      System.out.println(cluster+" load1: "+load1);
                    }
                    if (line.indexOf("load_five") != -1) {
                       int i3 = line.indexOf("SUM");
                       int i4 = line.indexOf("\"", i3+5);
                       load5 = new Float(line.substring(i3+5, i4)).doubleValue();
                       rrc.param[3]=load5;
//                       System.out.println(cluster+" load5: "+load5);
                    }
                  }
               }  // inner while loop
              rrc.param[2]=load1/ncpus;
              rrc.param[4]=load5/ncpus;
              clusterResults.add(rrc);
//              System.out.println(rrc);
             } // if CLUSTER 

             } //while loop
              rr.param[2]=gload1/gncpus;
              rr.param[4]=gload5/gncpus;
              clusterResults.add(rr);
//              System.out.println(rr);
          } //if GRID
        } // outer while loop
     }catch (IOException e) {
         System.out.println("Exception in reading from Ganglia: "+e);
     }

    return clusterResults;
}


static public void main ( String [] args ) {

  String host = args[0] ;
  int port = Integer.parseInt(args[1]);

  aGanglia2 aa = new aGanglia2 (); 
  String ad = null ;
  try {
    ad = InetAddress.getByName( host ).getHostAddress();
  } catch ( Exception e ) {
    System.out.println ( " Can not get ip for node " + e );
    System.exit(-1);
  }

  MonModuleInfo info = aa.init( new MNode (host ,ad,  null, null), host+","+port);



 try  {
  Object bb = aa.doProcess();
 } catch ( Exception e ) {
   System.out.println ( " failed to process " );
 }



}
    
 
}


